version: "3.4"
services:

  sas:
    image: robcast/simpleannotationserver:latest
    restart: unless-stopped
    ports: 
      - "8080:8080"
    volumes:
      - ./annotation-data:/annotation-data
      - ./projects:/usr/local/tomcat/webapps/sas/projects
      - ./index.html:/usr/local/tomcat/webapps/sas/index.html
    logging:
      driver: json-file
      options:
        max-size: "200k"
        max-file: "10"
    labels:
      - "traefik.enable=true"
      # create router for our host
      - "traefik.http.routers.sas.rule=Host(`${VIRTUAL_HOST:-sas.mpiwg-berlin.mpg.de}`)"
      # use TLS
      - "traefik.http.routers.sas.entrypoints=https"
      - "traefik.http.routers.sas.tls=true"
      - "traefik.http.routers.sas.tls.certresolver=letsencrypt"
      # use basic-auth middleware
      - "traefik.http.routers.sas.middlewares=sas-auth,sas-prefix"
      # define middleware
      - "traefik.http.middlewares.sas-auth.basicauth.usersfile=/etc/traefik/htusers"
      - "traefik.http.middlewares.sas-prefix.addprefix.prefix=/sas"

  proxy:
    image: traefik:v2.2
    restart: unless-stopped
    command:
      - "--entrypoints.http.address=:80"
      - "--entrypoints.https.address=:443"
      #- "--log.level=DEBUG"
      - "--api.insecure=true"
      - "--providers.docker=true"
      - "--providers.docker.exposedbydefault=false"
      - "--certificatesresolvers.letsencrypt.acme.email=itgroup@mpiwg-berlin.mpg.de"
      - "--certificatesresolvers.letsencrypt.acme.storage=/letsencrypt/acme.json"
      - "--certificatesresolvers.letsencrypt.acme.httpchallenge.entrypoint=http"
      - "--entrypoints.http.http.redirections.entryPoint.to=https"
      - "--entrypoints.http.http.redirections.entryPoint.scheme=https"
    ports:
      - "80:80"
      - "443:443"
      # The Web UI (enabled by api.insecure=true)
      - "8081:8080"
    volumes:
      - /var/run/docker.sock:/var/run/docker.sock:ro
      #- ./traefik.yml:/etc/traefik/traefik.yml:ro
      #- ./config:/etc/traefik/dynamic:ro
      #- ./certs:/etc/traefik/certs:ro
      - ./letsencrypt:/letsencrypt:rw
      #- ./log:/var/log:rw
      - ./htusers:/etc/traefik/htusers
